package sat.fit;

import fit.*;
import java.lang.reflect.*;

// Copyright (c) 2002 Rick Mugridge, University of Auckland.
// Released under the terms of the GNU General Public License version 2 or later.

    /** A fixture for running commands over the cells in a row
	@author rick mugridge, october 2002
    */
public abstract class ActionRowFixture extends Fixture {
    protected static final Class[] methodArgs = { Parse.class };

        /** Determine the action on this row and pass the remaining 
	    cells of the row
	*/ 
    public void doCells(Parse cells) {
        try {
            Method action = getClass().getMethod(cells.text(), methodArgs);
            action.invoke(this,new Object[]{cells});
        } catch (Exception e) {
            exception(cells, e);
        }
    }
        /** The execute method is called for each cell in the row that 
	    has some text
	 */
    protected interface ColumnCommand {
	public void execute(int column, Parse cell) throws Exception;
    }
        /** Call the command for each of the cells in the row that 
	    have some text
	 */
    protected void processColumns(Parse cells, ColumnCommand command) {
	cells = cells.more; // ignore first cell
	for (int i = 0; cells != null; i++, cells = cells.more) {
	    if (!cells.text().equals("")) {
		try {
		    command.execute(i,cells);
		} catch (Exception ex) {
		    exception(cells,ex);
		}
	    }
	}
    }
}
